package experiment;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

public class Agent {

	private List<Set<String>> vocabulary = new ArrayList<>(); // En liste over konsepter. For hvert konsept, en liste over ord.
	public int id;
	//private int[] numberOfDialogs;
	//private int[] numberOfSuccesses;
	private Random random = new Random();
	
	public Agent(List<Set<String>> vocabulary, int numberOfAgents) {
		this.vocabulary = vocabulary;
		//vocabulary.add(getNewWord()); // Bare s alle har ett ord fra starten
		//for (Set<String> concept : this.vocabulary) {
			//for (String word : concept)
				//System.out.println(this + " " + word);
		//}
		//numberOfDialogs = new int[numberOfAgents];
		//numberOfSuccesses = new int[numberOfAgents];
	}
	
	public Agent(int numberOfConcepts, int numberOfAgents, int id) {
		this.id = id;
		vocabulary = new ArrayList<>();
		for (int i = 0; i < numberOfConcepts; i++)
			vocabulary.add(new HashSet<>());
		//numberOfDialogs = new int[numberOfAgents];
		//numberOfSuccesses = new int[numberOfAgents];
	}
	
	public String speak(int concept) {
		//for (String word : vocabulary.get(concept))
			//System.out.print(word + " ");
		//System.out.println(" < speak");
		if (vocabulary.get(concept) == null) {
			//System.out.println("ikke contains");
			vocabulary.set(concept, new HashSet<>());
		}
		//System.out.println("speak, vocab " + vocabulary.size());
		//System.out.print("vocab speak: ");
		if (vocabulary.get(concept).isEmpty()) {
			//System.out.println("genererer nytt");
			//System.out.println();
			return getNewWord();
		}
		/*for (String word : vocabulary.get(concept))
			System.out.print(word + " ");*/
		//System.out.println();
		int size = vocabulary.get(concept).size();
		int item = random.nextInt(size);
		int i = 0;
		for (String word : vocabulary.get(concept)) {
		    if (i == item)
		        return word;
		    i++;
		}
		return null;
	}
	
	public boolean listen(int concept, String word) {
		//for (String w: vocabulary.get(concept))
			//System.out.print(w + " ");
		//System.out.println(" < listen");
		if (vocabulary.get(concept) == null)
			vocabulary.set(concept, new HashSet<>());
		//System.out.println("listen, vocab " + vocabulary.size());
		//System.out.print("vocab listen: ");
		/*for (String vocabWord : vocabulary.get(concept))
			System.out.print(vocabWord + " ");*/
		//System.out.println();
		return vocabulary.get(concept).contains(word);
	}
	
	public void retainOnly(int concept, String word) {
		vocabulary.get(concept).clear();
		vocabulary.get(concept).add(word);
	}
	
	public int getVocabularySize(int concept) {
		return vocabulary.get(concept).size();
	}
	
	public Set<String> getVocabulary(int concept) {
		return vocabulary.get(concept);
	}
	
	public void addWord(int concept, String word) {
		vocabulary.get(concept).add(word);
	}
	
	public int getNumberOfConcepts() {
		return vocabulary.size();
	}
	
	private String getNewWord() {
		char[] consonants = {'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Z'};
		char[] vowels = {'A', 'E', 'I', 'O', 'U', 'Y'};
		String word = "";
		boolean vowel;
		
		int firstIndex = random.nextInt(consonants.length + vowels.length);
		if (firstIndex < consonants.length) {
			word += consonants[firstIndex];
			vowel = false;
		}
		else {
			word += vowels[firstIndex - consonants.length];
			vowel = true;
		}
		
		for (int i = 0; i < 4; i++) {
			vowel = !vowel;
			char[] chars = vowel ? vowels : consonants;
			word += chars[random.nextInt(chars.length)];
		}
		
		return word;
	}
	
	/*public double getSuccessRate(int agentId) {
		return 1.0 * numberOfSuccesses[agentId] / numberOfDialogs[agentId];
	}
	
	public int getNumberOfDialogs(int agentId) {
		return numberOfDialogs[agentId];
	}
	
	public void incrementDialogs(int agentId) {
		numberOfDialogs[agentId]++;
	}
	
	public void incrementSuccesses(int agentId) {
		numberOfSuccesses[agentId]++;
	}*/
}
