package experiment;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

public class EA {

	private static Agent development(List<Set<String>> genotype, int numberOfAgents) {
		return new Agent(genotype, numberOfAgents);
	}
	
	public static Agent reproduction(Agent mother, Agent father, int numberOfAgents) {
		//System.out.println("reprod");
		List<Set<String>> genotype = transferVocabulary(mutation(mother), mutation(father));
		return development(genotype, numberOfAgents);
	}

	private static List<Set<String>> transferVocabulary(List<Set<String>> genotype1, List<Set<String>> genotype2) {
		List<Set<String>> newGenotype = new ArrayList<>();
		for (int i = 0; i < genotype1.size(); i++) {
			newGenotype.add(new HashSet<>());
			newGenotype.get(i).addAll(genotype1.get(i));
			newGenotype.get(i).addAll(genotype2.get(i));
		}
		return newGenotype;
	}

	private static List<Set<String>> mutation(Agent agent) {
		Random random = new Random();
		double mutationRate = 0.03;
		
		List<Set<String>> mutatedVocabulary = new ArrayList<>();
		for (int i = 0; i < agent.getNumberOfConcepts(); i++) {
			mutatedVocabulary.add(new HashSet<>());
			//System.out.println("size of" + agent.getVocabularySize(i));
			for (String word : agent.getVocabulary(i)) {
				//System.out.println("w i vocab: " + word);
				if (random.nextDouble() < mutationRate)
					mutatedVocabulary.get(i).add(mutate(word));
				else
					mutatedVocabulary.get(i).add(word);
			}
		}
		return mutatedVocabulary;
	}
	
	private static String mutate(String word) {
		//System.out.println("mutate");
		char[] consonants = {'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Z'};
		char[] vowels = {'A', 'E', 'I', 'O', 'U', 'Y'};
		Random random = new Random();
		int randomLetter = random.nextInt(word.length());
		//System.out.println(randomLetter);
		char oldLetter = word.charAt(randomLetter);
		//System.out.println(oldLetter);
		char newLetter;
		do {
			newLetter = new String(consonants).indexOf(oldLetter) != -1 ? consonants[random.nextInt(consonants.length)] : vowels[random.nextInt(vowels.length)];
			//System.out.println(newLetter);
	}
		while (newLetter == oldLetter);
		//System.out.println(word.substring(0, randomLetter) + "+" + newLetter + "+" + word.substring(randomLetter + 1));
		return word.substring(0, randomLetter) + newLetter + word.substring(randomLetter + 1);
	}

}
