package lipowski_lipowska;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class Agent {

	private List<String> vocabulary = new ArrayList<>();
	private Random random = new Random();
	
	public Agent() {
		//vocabulary.add(getNewWord()); // Bare s alle har ett ord fra starten
	}
	
	public String speak() {
		//System.out.println("speak, vocab " + vocabulary.size());
		if (vocabulary.isEmpty()) {
			String newWord = getNewWord();
			addWord(newWord);
		}
			//return getNewWord();
		return vocabulary.get(random.nextInt(vocabulary.size()));
	}
	
	public boolean listen(String word) {
		//System.out.println("listen, vocab " + vocabulary.size());
		return vocabulary.contains(word);
	}
	
	public void retainOnly(String word) {
		vocabulary.clear();
		vocabulary.add(word);
	}
	
	public int getVocabularySize() {
		return vocabulary.size();
	}
	
	public List<String> getVocabulary() {
		return vocabulary;
	}
	
	public void addWord(String word) {
		vocabulary.add(word);
	}
	
	private String getNewWord() {
		char[] consonants = {'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Z'};
		char[] vowels = {'A', 'E', 'I', 'O', 'U', 'Y'};
		String word = "";
		boolean vowel;
		
		int firstIndex = random.nextInt(consonants.length + vowels.length);
		if (firstIndex < consonants.length) {
			word += consonants[firstIndex];
			vowel = false;
		}
		else {
			word += vowels[firstIndex - consonants.length];
			vowel = true;
		}
		
		for (int i = 0; i < 4; i++) {
			vowel = !vowel;
			char[] chars = vowel ? vowels : consonants;
			word += chars[random.nextInt(chars.length)];
		}
		
		return word;
	}
}
